// This is NEW CODE defining structures & constants needed by system calls.
// This code should be used by both the kernel and the user-mode programs or
// libraries attempting to use any complex system calls.
#ifndef _SYSCDEFS_H_
#define _SYSCDEFS_H_

// This needs to be the same limit as in drives.h, but probably doesn't need to
// change much:
#define __SYSCDEFS_DRIVES_NAMEMAX   24

struct __syscdefs_driveinfo {
  int drivenumber;
  unsigned int blocksize;
  unsigned long long freedatablocks;
  unsigned long long totalblocks;
  char name[__SYSCDEFS_DRIVES_NAMEMAX];
  char fsname[__SYSCDEFS_DRIVES_NAMEMAX];
};

// From ifndef at top of file:
#endif

